%global debug_package %{nil}

Name:         uboot-rpi
License:      GPLv2
Version:      2025.01
Release:      1.0.4%{?dist}
Summary:      u-boot for Raspberry Pi 3 & 4
Group:        System Environment/Kernel
Source0:      https://github.com/u-boot/u-boot/archive/v%{version}.tar.gz#/u-boot-%{version}.tar.bz2
## See SOURCE file for uboot repo and version

#Patches
Patch0005:    0005-smbios-Fix-table-when-no-string-is-.patch
Patch0007:    0007-Disable-splash-screen.patch
Patch0010:    0010-Enable-SYS_USB_EVENT_POLL_VIA_CONTROL_EP-for-rpi_3-a.patch
Patch0011:    0011-Increase-usb_pgood_delay-to-1000.patch
Patch0015:    0015-uefi-Add-all-options-for-EFI-System-Partitions.patch
Patch0016:    0016-Bootmeth_efi-loads-grub.patch
Patch0017:    0017-Disable-bootmgr-support.patch
Patch0018:    0018-Enable-bootstd_full.patch
Patch0020:    0020-Revert-mmc-bcm2835-host-let-firmware-manage-the-cloc.patch
Patch0030:    0030-openssl-no-engine.patch


BuildRequires: dtc
BuildRequires: bison
BuildRequires: flex
BuildRequires: openssl-devel
BuildRequires: bc
BuildRequires: gcc
BuildRequires: gnutls-devel

%if 0%{?rhel} < 8
BuildRequires: devtoolset-6-gcc
%define with_devtoolset 1
%endif

%description
u-boot for Raspberry Pi 3 & 4

%prep
%autosetup -n u-boot-%{version} -p 1


%build

%{?with_devtoolset: scl enable devtoolset-6 --} make O=rpiarm64 rpi_arm64_defconfig
%{?with_devtoolset: scl enable devtoolset-6 --} make O=rpiarm64 %{?_smp_mflags}

%install
mkdir -p %{buildroot}/boot/efi
cp -v  rpiarm64/u-boot.bin %{buildroot}/boot/efi/u-boot.bin

%files
/boot/efi/u-boot.bin

%changelog
* Fri Apr 11 2025 Filip Zaludek <filip.zaludek@oracle.com> - 2025.01-1.0.4
- Replace %%patch with %%autosetup, suggested by Lukas Lipinsky <lukas.lipinsky@oracle.com>
- Patch0030: Build with OPENSSL_NO_ENGINE
- Reintroduced 0020-Revert-mmc-bcm2835-host-let-firmware-manage-the-cloc.patch [Orabug 36073094]

* Tue Mar 25 2025 Filip Zaludek <filip.zaludek@oracle.com> - 2025.01-1.0.3
- Circumvent standard UEFI boot mechanism by avoiding /EFI/BOOT/BOOTAA64.EFI [Orabug 36554488]
- Removed 0002-rpi-Use-firmware-provided-device-tr.patch and 0003-Add-efidebug-command.patch

* Fri Mar 07 2025 Filip Zaludek <filip.zaludek@oracle.com> - 2025.01-1.0.2
- Removed configuration changes not related to 'rpi_arm64_defconfig'

* Tue Mar 04 2025 Filip Zaludek <filip.zaludek@oracle.com> - 2025.01-1.0.1
- Updated to latest stable DAS uboot repo. (2025.01)
- Extra dependency 'BuildRequires: gcc' [Orabug 37508616]

* Tue May 14 2024 Filip Zaludek <filip.zaludek@oracle.com> - 2024.04-1.0.2
- Adjusted bootmeth EFI to boot from an grubaa64.efi file to mitigate [Orabug 36554488]
- Disabled bootmgr support to mitigate [Orabug 36554488]
- Enabled CONFIG_BOOTSTD_FULL

* Fri Apr 26 2024 Filip Zaludek <filip.zaludek@oracle.com> - 2024.04-1.0.1
- Updated to latest stable DAS uboot repo. (2024.04)
- Removed 0001-Change-refs-from-bootaa64-to-grubaa64.patch
- Removed 0020-Revert-mmc-bcm2835-host-let-firmware-manage-the-cloc.patch
- Added 0015-uefi-Add-all-options-for-EFI-System-Partitions.patch

* Fri Dec 08 2023 Filip Zaludek <filip.zaludek@oracle.com> - 2023.07-1.0.2
- Revert "mmc: bcm2835-host: let firmware manage the clock divisor" [Orabug 36073094]

* Wed Nov 08 2023 Filip Zaludek <filip.zaludek@oracle.com> - 2023.07-1.0.1
- Updated to stable DAS uboot repo. (2023.07)
- Unused patches dropped:
  0004-Raspberry-Pi-UEFI-Runtime-regions-are-not-aligned-to.patch
        64k alignment patch is no more compatible with current u-boot,
        also note that from UEK7 default kernel page size for aarch64 is 4k
  0006-Disable-timer-check-in-file-loading.patch
        Experimantal patch for troubleshooting RPi3 keyboard glitches
  0008-Revert-Limit-poll-frequency-to-improve-performance.patch
        RPi3 keyboard glitches addressed by CONFIG_SYS_USB_EVENT_POLL_VIA_CONTROL_EP=y
  0009-usb-kbd-dwc2-Increase-wait-for-dwc2-controller-reset.patch
        RPi3 keyboard glitches addressed by CONFIG_SYS_USB_EVENT_POLL_VIA_CONTROL_EP=y
- Increase usb_pgood_delay to 1000 to help RPi Zero 2 W to detect more keyboard vendors

* Wed May 17 2023 Filip Zaludek <filip.zaludek@oracle.com> - 2023.04-1.0.1
- Updated to latest stable DAS uboot repo. (2023.04)
- Enabled CONFIG_SYS_USB_EVENT_POLL_VIA_CONTROL_EP=y [Orabug 31562826]

* Mon Nov 14 2022 Filip Zaludek <filip.zaludek@oracle.com> - 2022.10-1.0.2
- Reverted RPi3 unfriendly '0006-Disable-timer-check-in-file-loading.patch'
- Reverted RPi3 unfriendly '0008-Revert-Limit-poll-frequency-to-improve-performance.patch'

* Fri Oct 07 2022 Filip Zaludek <filip.zaludek@oracle.com> - 2022.10-1.0.1
- Updated to latest stable DAS uboot repo. (2022.10)

* Tue Aug 30 2022 Filip Zaludek <filip.zaludek@oracle.com> - 2022.07-1.0.1
- Updated to latest stable DAS uboot repo. (2022.07)

* Wed Apr 13 2022 Filip Zaludek <filip.zaludek@oracle.com> - 2022.04-1.0.2
- Disabled splash screen

* Wed Apr 13 2022 Filip Zaludek <filip.zaludek@oracle.com> - 2022.04-1.0.1
- Updated uboot to latest DAS uboot repo.

* Tue Mar 15 2022 Filip Zaludek <filip.zaludek@oracle.com> - 2022.01-1.0.2
- Fixed Source0 reference
- BuildRequires: openssl-devel

* Fri Jan 28 2022 Filip Zaludek <filip.zaludek@oracle.com> - 2022.01-1.0.1
- Updated uboot to latest DAS uboot repo.
- env: fat: Add new lines at the end of print statements

* Tue Jul 20 2021 Filip Zaludek <filip.zaludek@oracle.com> - 2021.04-1.0.3
- efi_smbios_register(), allocate EFI_ALLOCATE_64K_ALIGN pages in lowmem then in highmem
- clean up artifacts

* Sun Jul 18 2021 Filip Zaludek <filip.zaludek@oracle.com> - 2021.04-1.0.2
- Adapted '0020-Raspberry-Pi-UEFI-Runtime-regions-are-not-aligned-to.patch' to 2021.04

* Thu Jun 3 2021 Filip Zaludek <filip.zaludek@oracle.com> - 2021.04-1.0.1
- Customized distro_bootcmd
- Enabled efidebug command
- Common u-boot rpiarm64 binary for both RPi3 and RPi4 platforms

* Wed Oct 7 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.7
- Added efi runtime align fix for kernel-uek 5.4.17-2011.6.2

* Mon Jul 6 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.6
- Add bmp cmd support.

* Sat Jun 27 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.5
- fix totol memory issue on 8G RPI4 [Orabug 31562826]

* Fri Jun 26 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.4
- fix USB device discovery issue

* Thu Jun 25 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.3
- clean up git residual

* Wed Jun 24 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.2
- port uboot env config changes
- Fix PCI probe for RPi4
- Fix USB controller for RPi4
- Enable ethernet, pci, usb on RPi4
- Fix uboot to see correct memory on OS for 8GB RPi4

* Tue Jun 23 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.1
- Updated uboot to latest DAS uboot repo.

* Thu Apr 16 2020 David Sloboda <david.x.sloboda@oracle.com> - 2020.01-1.0.6
- Change Release: remove character "v" (request from Filip Zaludek)

* Mon Apr 06 2020 Filip Zaludek <filip.zaludek@oracle.com> - v2020.01-1.0.5
- Add devtoolset-6 dependency for OL7.x, lukas.lipinsky@oracle.com

* Fri Apr 03 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - v2020.01-1.0.4
- Add missing BuildRequires [Orabug 31121792]

* Fri Jan 31 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - v2020.01-1.0.3
- Fix fdt load address [Orabug 30838900]

* Sun Dec 15 2019 Vijay Kumar <vijay.ac.kumar@oracle.com> - v2020.01-1.0.2
- Fix for "UEFI Runtime regions are not aligned to 64 KB". [Orabug 30665128]

* Wed Nov 06 2019 Vijay Kumar <vijay.ac.kumar@oracle.com> - v2020.01-1.0.1
- Initial build
- Ported rpi3 uboot patches
